local M = {}

local movingParts = {
	Turret = {
			  ["moving"] = false, 
			  ["moveDirection"] = 0,
			  ["electric"]= "turret_rotate",
			  ["lowerLimit"] = -1.0,
			  ["upperLimit"] = 1.0,
			},
	Gun = {
			  ["moving"] = false, 
			  ["moveDirection"] = 0,
			  ["electric"]= "gun_raise",
			  ["lowerLimit"] = 0.0,
			  ["upperLimit"] = 1.0,
			},
	Covers = {
			  ["moving"] = false, 
			  ["moveDirection"] = 0,
			  ["electric"]= "covers_lower",
			  ["lowerLimit"] = 0.0,
			  ["upperLimit"] = 1.0,
			},
			
}

local sensitivity = 0.04

local function resetHydros()
	for k,p in pairs(movingParts) do
		electrics.values[p.electric] = 0
		p.moving = false
		p.moveDirection = 0
	end			
end

local function init()
	print("")
	resetHydros()
end

local function reset()
	init()
end

local function clampValue(minval,maxval,val)
	if val > maxval then return maxval end
	if val < minval then return minval end
	return val
end

local function setPartMoving(PartName,direction)
		movingParts[PartName].moving = true
		movingParts[PartName].moveDirection = direction
end

local function updateGFX(dt)
	if input.keys.Y then
		resetHydros()
	end
	
	if input.keys.H then
		setPartMoving("Turret",1)
	elseif input.keys.F then
		setPartMoving("Turret",-1)
	end

	if input.keys.T then
		setPartMoving("Gun",1)
	elseif input.keys.G then
		setPartMoving("Gun",-1)
	end

	if input.keys.E then
		setPartMoving("Covers",1)
	elseif input.keys.E then
		setPartMoving("Covers",-1)
	end

	for k,p in pairs(movingParts) do
		if p.moving then
			local incAmount = (sensitivity * (bullettime.simulationSpeed / 1))
			local hydroVal = electrics.values[p.electric]
			hydroVal = hydroVal +  (incAmount * p.moveDirection)
			hydroVal = clampValue(p.lowerLimit,p.upperLimit,hydroVal)
			electrics.values[p.electric] = hydroVal
			if hydroVal == p.lowerLimit or hydroVal == p.upperLimit then p.moving = false end
		end
	end
end

-- public interface
M.init      = init
M.reset     = reset
M.updateGFX = updateGFX

return M